package models

import "gorm.io/gorm"

// An emote is effectively an assignment of a name and server
type Emote struct {
	gorm.Model
	// Media used for this emote
	Metadata   MediaMetadata // `gorm:"foreignKey:MetadataId"`
	MetadataId string
	// Name of the emote. Also the text for using it in a message (ex. :bob:)
	Name string
	// Server the emote is from
	Server   RemoteServer // `gorm:"foreignKey:ServerId;references:ID"`
	ServerId uint
}
