package models

import (
	"database/sql/driver"
)

// The software a server is running
type ServerSoftwareType string

const (
	// Includes forks like glitch-soc, etc
	ServerSoftwareMastodon = ServerSoftwareType("Mastodon")
	// Includes forks like Ice Shrimp, Sharkey, Cutiekey, etc
	ServerSoftwareMisskey = ServerSoftwareType("Misskey")
	// Includes Akkoma
	ServerSoftwarePlemora = ServerSoftwareType("Plemora")
	// Wafrn is a new entry
	ServerSoftwareWafrn = ServerSoftwareType("Wafrn")
	// And of course, yours truly
	ServerSoftwareLinstrom = ServerSoftwareType("Linstrom")
)

var AllServerSoftwareTypes = []ServerSoftwareType{
	ServerSoftwareMastodon,
	ServerSoftwareMisskey,
	ServerSoftwarePlemora,
	ServerSoftwareWafrn,
	ServerSoftwareLinstrom,
}

func (r *ServerSoftwareType) Value() (driver.Value, error) {
	return r, nil
}

func (ct *ServerSoftwareType) Scan(value any) error {
	*ct = ServerSoftwareType(value.(string))
	return nil
}
