package models

import "database/sql/driver"

// How one account relates to another
type RelationType string

const (
	RelationFollow        RelationType = "follow"
	RelationMute          RelationType = "mute"
	RelationNoBoosts      RelationType = "no-boosts"
	RelationBlock         RelationType = "block"
	RelationPreventFollow RelationType = "prevent-follow"
)

// var AllBeings = []BeingType{BEING_HUMAN, BEING_CAT, BEING_FOX, BEING_DOG, BEING_ROBOT, BEING_DOLL}
var AllRelations = []RelationType{
	RelationFollow,
	RelationMute,
	RelationNoBoosts,
	RelationBlock,
	RelationPreventFollow,
}

func (ct *RelationType) Scan(value any) error {
	*ct = RelationType(value.([]byte))
	return nil
}

func (ct RelationType) Value() (driver.Value, error) {
	return string(ct), nil
}
